// Copyright (C) 1998-1999 Scott Cutler
// Please see the "readme.txt" file for license details

#define  STRICT
#define  D3D_OVERLOADS

#define __WIN32__

#include <math.h>
#include <time.h>
#include <stdio.h>
#include <iostream.h>
#include <fstream.h>

#include <ddraw.h>
#include <d3d.h>
#include <d3dframe.h>

#include "D3DUtil.h"
#include "D3DEnum.h"
#include "D3DMath.h"

#include "glide.h"
#include "glideutl.h"

typedef FxU32 GrHints_t;

#define LOG
//#define VERBOSE_LOG

#ifdef LOG
#define log(text) { of.open("glide.log", ios::app); of << text << "\n"; of.close(); }
//#define log(text) { of << text << "\n"; of.flush(); }
#else
#define log(test) {}
#endif

#ifdef VERBOSE_LOG
#define vlog(text) { of.open("glide.log", ios::app); of << text << "\n"; of.close(); }
//#define vlog(text) { of << text << "\n"; of.flush(); }
#else
#define vlog(test) {}
#endif


#define _tmuRam 2
#define MAX_TEXTURES 2048


extern D3DCOLOR colorconv2(GrColor_t);
extern D3DCOLOR iterated(float, float, float, float);
extern D3DCOLOR iterated2(float, float, float, float);
extern D3DCOLOR iterconst(float, float, float, float);
extern D3DCOLOR constant(float, float, float, float);
extern D3DCOLOR constant2(float, float, float, float);
extern D3DCOLOR white(float, float, float, float);
extern D3DCOLOR black(float, float, float, float);

extern D3DTLVERTEX vconv(const GrVertex & v);
extern GrTextureFormat_t getTextureFormat(char *);
extern GrAspectRatio_t getAspectRatio(FxU32, FxU32);
extern FxU32 getBytesPerPixel(GrTextureFormat_t);
extern FxU32 getMemRequired(Gu3dfInfo *, FxU32, FxU32);
extern FxU32 TexMemCalc(FxU32, GrLOD_t, GrLOD_t, GrAspectRatio_t, GrTextureFormat_t);

extern ofstream of;

extern HRESULT hr;
extern HINSTANCE _hInstance;

extern LPDIRECTDRAW4			_lpDD;         // DirectDraw Interface
extern LPDIRECT3D3				_lpD3D;        // Direct3D3 Interface
extern LPDIRECTDRAWSURFACE4		_lpDDSRender;  // Rendering surface
extern LPDIRECT3DDEVICE3		_lpD3DD;  // D3D Device
extern DDSURFACEDESC2			_lpDDSurfaceDesc;
extern LPDIRECT3DVIEWPORT3		_lpD3DViewport;

extern CD3DFramework			*_lpD3DFrame;
extern D3DEnum_DriverInfo		*pDriverInfo;
extern D3DEnum_DeviceInfo		*pDeviceInfo;
extern DWORD					dwFrameworkFlags;

extern const int				_tmuRamBytes;
extern HWND						_hWnd;
extern GrScreenResolution_t		_screen_resolution;
extern GrScreenRefresh_t		_refresh_rate;
extern GrColorFormat_t			_color_format;
extern GrOriginLocation_t		_origin_location;
//extern int						_nColBuffers;
//extern int						_nAuxBuffers;
extern GrAlpha_t				_alphaRef;
extern FxI16					_depthBias;
extern GrCmpFnc_t				_depthFunc;
extern FxFloat					*smul;
extern FxFloat					*tmul;

extern D3DCOLOR					_constantColor;

extern char						*_tmuMem;

extern D3DMATRIX				_idenMat;

extern D3DRECT					_D3DViewportRect;

extern GrErrorCallbackFnc_t		_errorFnc;

#include "Tex.h"
#include "TexList.h"


struct sVoodoo {
	FxU32						fbRam;
	FxU32						width;
	FxU32						height;
	GrDepthBufferMode_t			dbMode;
	PALETTEENTRY				palette[256];
	Tex							*curtex;
	D3DVIEWPORT2				viewport;
	GrOriginLocation_t			origin;

	D3DCOLOR					constantColor;
	FxFloat						CCR, CCG, CCB, CCA;

	FxU32						ccLocal;
	FxU32						ccFunc;

	int							uclamp;
	int							vclamp;

//	int							lastpolytype;
};

extern sVoodoo Voodoo;

extern D3DCOLOR (*getcolor)(float, float, float, float);






//extern Tex						*_curtex;
extern TexList					_texlist;













