// Copyright (C) 1998-1999 Scott Cutler
// Please see the "readme.txt" file for license details

#include "include.h"



/* Important */

FX_ENTRY void FX_CALL grDrawPlanarPolygonVertexList( int nverts, const GrVertex vlist[] ) {
	vvlog("Called grDrawPlanarPolygonVertexList");

	_lpD3DD->Begin(D3DPT_TRIANGLEFAN, D3DFVF_TLVERTEX, D3DDP_DONOTLIGHT);
	for (int i=0; i<nverts; i++) 
		_lpD3DD->Vertex((LPVOID)&vconv(vlist[i]));
	_lpD3DD->End(0);
}


/* Only for Marble32 */
FX_ENTRY void FX_CALL grDrawTriangle(const GrVertex *a, const GrVertex *b, const GrVertex *c ) {
	vvlog("Called grDrawTriangle");

	_lpD3DD->Begin(D3DPT_TRIANGLELIST, D3DFVF_TLVERTEX, D3DDP_DONOTLIGHT);
		_lpD3DD->Vertex((LPVOID)&vconv(*a));
		_lpD3DD->Vertex((LPVOID)&vconv(*b));
		_lpD3DD->Vertex((LPVOID)&vconv(*c));
	_lpD3DD->End(0);
}


/* Important */
FX_ENTRY void FX_CALL grDrawPolygonVertexList( int nverts, const GrVertex vlist[] ) {
	vvlog("Called grDrawPolygonVertexList");

	_lpD3DD->Begin(D3DPT_TRIANGLEFAN, D3DFVF_TLVERTEX, D3DDP_DONOTLIGHT);
	for (int i=0; i<nverts; i++) 
		_lpD3DD->Vertex((LPVOID)&vconv(vlist[i]));
	_lpD3DD->End(0);
}


/* Only for Marble32 */
FX_ENTRY void FX_CALL grAADrawTriangle( const GrVertex *a, const GrVertex *b, const GrVertex *c, FxBool ab_antialias, FxBool bc_antialias, FxBool ca_antialias) {
	vvlog("Called grAADrawTriangle");

	_lpD3DD->Begin(D3DPT_TRIANGLELIST, D3DFVF_TLVERTEX, D3DDP_DONOTLIGHT);
		_lpD3DD->Vertex((LPVOID)&vconv(*a));
		_lpD3DD->Vertex((LPVOID)&vconv(*b));
		_lpD3DD->Vertex((LPVOID)&vconv(*c));
	_lpD3DD->End(0);
}


FX_ENTRY void FX_CALL grDrawLine( const GrVertex *v1, const GrVertex *v2 ) {

	_lpD3DD->Begin(D3DPT_LINELIST, D3DFVF_TLVERTEX, D3DDP_DONOTLIGHT);
		_lpD3DD->Vertex((LPVOID)&vconv(*v1));
		_lpD3DD->Vertex((LPVOID)&vconv(*v2));
	_lpD3DD->End(0);
}

FX_ENTRY void FX_CALL grDrawPoint( const GrVertex *pt ) {
	vvlog("Called grDrawPoint");

	_lpD3DD->Begin(D3DPT_POINTLIST, D3DFVF_TLVERTEX, D3DDP_DONOTLIGHT);
		_lpD3DD->Vertex((LPVOID)&vconv(*pt));
	_lpD3DD->End(0);
}

FX_ENTRY void FX_CALL grDrawPlanarPolygon( int nverts, const int ilist[], const GrVertex vlist[] ) {
	vvlog("Called grDrawPlanarPolygon");

	_lpD3DD->Begin(D3DPT_TRIANGLEFAN, D3DFVF_TLVERTEX, D3DDP_DONOTLIGHT);
	for (int i=0; i<nverts; i++) 
		_lpD3DD->Vertex((LPVOID)&vconv(vlist[ilist[i]]));
	_lpD3DD->End(0);
}
