// Copyright (C) 1998-1999 Scott Cutler
// Please see the "readme.txt" file for license details

#include "include.h"


TexList::TexList() {
	vlog("Called TexList::TexList");

	int i;

	for (i=0; i<MAX_TEXTURES; i++) _list[i] = 0;
}

TexList::~TexList() {
	vlog("Called TexList::~TexList");

	int i;

//	for (i=0; i<MAX_TEXTURES; i++) delete _list[i];
}

void TexList::AddTex(const FxU32 address, const GrTexInfo &t) {
	vlog("Called TexList::AddTex");

	int i;

	Tex *newtex = new Tex(address, t);

	if (newtex->tex()) {
		DeleteOverwritten(*newtex);

		for (i=0; i<MAX_TEXTURES; i++) {
			if (_list[i] == 0) {
				_list[i] = newtex;
				return;
			}
		}
	}

	log("Error: exceeded max texture limit");
}

Tex * TexList::GetTex(const FxU32 address, const GrTexInfo & t) {
	vlog("Called TexList::GetTex");

	int i;

	for (i=0; i<MAX_TEXTURES; i++) {
		if (_list[i]) {
			if (address == _list[i]->base()) {
				if (_list[i]->paletted()) _list[i]->setpalette();
				return _list[i];
			}
		}
	}

	GrTexInfo info = t;

	info.data = (void *)address;
	AddTex(address, info);

	return GetTex(address, info);
//	return 0;
}

void TexList::DeleteOverwritten(const Tex &t) {
	vlog("Called TexList::DeleteOverwritten");
	int i;

	for (i=0; i<MAX_TEXTURES; i++) {
		if (_list[i] && intersect(*_list[i], t)) {
			vlog("Deleted texture at address " << _list[i]);
			delete _list[i];
			if (Voodoo.curtex == _list[i]) Voodoo.curtex = 0;
			_list[i] = 0;
		}
	}

}