// Copyright (C) 1998-1999 Scott Cutler
// Please see the "readme.txt" file for license details

#include "include.h"


FX_ENTRY FxU32 FX_CALL grSstStatus( void ) {

	return 1;
}


FX_ENTRY void FX_CALL grSstIdle(void) {
	
}

FX_ENTRY FxBool FX_CALL grSstIsBusy( void ) {

	return 0;
}



/* Important */
FX_ENTRY FxBool FX_CALL grSstWinOpen(FxU32 hWnd, GrScreenResolution_t screen_resolution, GrScreenRefresh_t refresh_rate, GrColorFormat_t color_format, GrOriginLocation_t origin_location, int nColBuffers, int nAuxBuffers) {
	log("Called grSstWinOpen");
	log("  hWnd=" << hWnd);
	log("  res=" << screen_resolution);
	log("  refresh=" << refresh_rate);
	log("  color format=" << color_format);
	log("  origin=" << origin_location);
	log("  # col buffers=" << nColBuffers);
	log("  # aux buffers=" << nAuxBuffers);
/*
	switch (screen_resolution) {
	case GR_RESOLUTION_320x200:   break;
	case GR_RESOLUTION_320x240:   break;
	case GR_RESOLUTION_400x256:   break;
	case GR_RESOLUTION_512x384:   break;
	case GR_RESOLUTION_640x200:   break;
	case GR_RESOLUTION_640x350:   break;
	case GR_RESOLUTION_640x400:   break;
	case GR_RESOLUTION_640x480:   break;
	case GR_RESOLUTION_800x600:   break;
	case GR_RESOLUTION_960x720:   break;
	case GR_RESOLUTION_856x480:   break;
	case GR_RESOLUTION_512x256:   break;
	case GR_RESOLUTION_1024x768:  break;
	case GR_RESOLUTION_1280x1024: break;
	case GR_RESOLUTION_1600x1200: break;
	case GR_RESOLUTION_400x300:   break;
	case GR_RESOLUTION_NONE:      log("Error: invalid resolution.\n"); return FALSE;
	}
*/	
	
	
	
	//	return FXTRUE;

	_hWnd = (HWND)hWnd;
//	_hWnd = 0;
	_screen_resolution = screen_resolution;
	_refresh_rate = refresh_rate;
	_color_format = color_format;
	Voodoo.origin = origin_location;
//	_nColBuffers = nColBuffers;
//	_nAuxBuffers = nAuxBuffers;
	Voodoo.dbMode = GR_DEPTHBUFFER_DISABLE;
	Voodoo.width = 640;
	Voodoo.height = 480;

//	WNDCLASS wndClass = { CS_HREDRAW | CS_VREDRAW, WndProc, 0, 0, _hInstance, 0, 0, 0, 0, TEXT("MyWindow") };
	WNDCLASS wndClass = { CS_HREDRAW | CS_VREDRAW, DefWindowProc, 0, 0, _hInstance, 0, 0, 0, 0, TEXT("MyWindow") };


	if(!_hWnd) {
		_hWnd = GetActiveWindow();

		char wndName[256];

		GetWindowText(_hWnd, wndName, sizeof(wndName));
		log("  Used window name='" << wndName << "'");
	}

	if (!_hWnd) {
		if (!RegisterClass( &wndClass )) {
			log("  Could not register window class");
			return FXFALSE;
		}

		if (!(_hWnd = CreateWindow("MyWindow", "MyWindow", WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, CW_USEDEFAULT, 300, 300, 0, 0, _hInstance, 0 ))) {
			log("  Could not create window");
			return FXFALSE;
		}
		ShowWindow(_hWnd, SW_SHOWNORMAL);
		UpdateWindow(_hWnd);
	}


	if (FAILED(D3DEnum_EnumerateDevices(0))) {
		log("  Error enumerating devices");
		return FXFALSE;
	}

//	D3DEnum_UserDlgSelectDriver(_hWnd, 0);
	D3DEnum_SelectDefaultDriver(D3DENUM_PRIMARYHAL);

	if (FAILED(D3DEnum_GetSelectedDriver(&pDriverInfo, &pDeviceInfo))) {
		log("  Error getting driver info");
		return FXFALSE;
	}

	if (!pDriverInfo || !pDeviceInfo) {
		log("  Error getting driver info");
	} else {
		log("  pDriverInfo:");
		log("    " << pDriverInfo->strName);
		log("    " << pDriverInfo->strDesc);
		log("  pDeviceInfo:");
		log("    " << pDeviceInfo->strName);
		log("    " << pDeviceInfo->pCurrentMode->strDesc);
	}


	log("  Attempting to call CD3DFramework::Initialize");

	dwFrameworkFlags = D3DFW_FULLSCREEN | D3DFW_ZBUFFER | D3DFW_BACKBUFFER;
//	dwFrameworkFlags = D3DFW_ZBUFFER | D3DFW_BACKBUFFER;
	
	log("  Window: " << (long)_hWnd);
	hr = _lpD3DFrame->Initialize((HWND)_hWnd, &pDriverInfo->guid, &pDeviceInfo->guid, &pDeviceInfo->pCurrentMode->ddsd, dwFrameworkFlags);
	if (SUCCEEDED(hr)) {
		log("  Succeeded calling CD3DFramework::Initialize");
	} else if (hr == E_INVALIDARG) {
		log("  Invalid arguments on CD3DFramework::Initialize");
		return FXFALSE;
	} else if (hr == D3DFWERR_INITIALIZATIONFAILED) {
		log("  D3DFWERR on CD3DFramework::Initialize");
		return FXFALSE;
	} else {
		log("  Failed on CD3DFramework::Initialize, error code " << (hr&0xFFFF));
		return FXFALSE;
	}


	log("  Now attempting to retrieve variables from CD3DFramework");

	_lpD3DViewport = _lpD3DFrame->GetViewport();
	_lpDD = _lpD3DFrame->GetDirectDraw();
	_lpD3D = _lpD3DFrame->GetDirect3D();
	if (!(_lpD3DD = _lpD3DFrame->GetD3DDevice())) {
		log("  Error retrieving D3DDevice");
		return FXFALSE;
	}
	_lpDDSRender = _lpD3DFrame->GetRenderSurface();


// Init viewport state variables
	Voodoo.viewport.dwSize = sizeof(D3DVIEWPORT2);
	Voodoo.viewport.dvClipX = 0;
	Voodoo.viewport.dvClipY = 0;
	Voodoo.viewport.dvClipWidth = 640;
	Voodoo.viewport.dvClipHeight = 480;
	Voodoo.viewport.dvMinZ = 0;
	Voodoo.viewport.dvMaxZ = 1;

	grClipWindow(0, 0, 640, 480);

// Init texture scaling vars for different aspect ratios
	smul = new FxFloat[21];  // More than enough, just to be safe
	tmul = new FxFloat[21];

	smul += 11;		// I can't tell for sure, but it looks like in some cases the
	tmul += 11;		// aspect ratio indexes could be negative.  Doing this keeps this
					// from having an access violation.

	smul[GR_ASPECT_8x1] = 1.0f / 256.0f;
	smul[GR_ASPECT_4x1] = 1.0f / 256.0f;
	smul[GR_ASPECT_2x1] = 1.0f / 256.0f;
	smul[GR_ASPECT_1x1] = 1.0f / 256.0f;
	smul[GR_ASPECT_1x2] = 1.0f / 128.0f;
	smul[GR_ASPECT_1x4] = 1.0f / 64.0f;
	smul[GR_ASPECT_1x8] = 1.0f / 32.0f;
	tmul[GR_ASPECT_8x1] = 1.0f / 32.0f;
	tmul[GR_ASPECT_4x1] = 1.0f / 64.0f;
	tmul[GR_ASPECT_2x1] = 1.0f / 128.0f;
	tmul[GR_ASPECT_1x1] = 1.0f / 256.0f;
	tmul[GR_ASPECT_1x2] = 1.0f / 256.0f;
	tmul[GR_ASPECT_1x4] = 1.0f / 256.0f;
	tmul[GR_ASPECT_1x8] = 1.0f / 256.0f;


	getcolor = iterated;



	log("  Retrieved variables from CD3DFramework");

// D3DRENDERSTATETYPE
	_lpD3DD->SetRenderState(D3DRENDERSTATE_TEXTUREPERSPECTIVE, TRUE);
//	_lpD3DD->SetRenderState(D3DRENDERSTATE_WRAPU, TRUE);
//	_lpD3DD->SetRenderState(D3DRENDERSTATE_WRAPV, TRUE);
//	_lpD3DD->SetRenderState(D3DRENDERSTATE_ZENABLE, D3DZB_TRUE);
	_lpD3DD->SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE, TRUE);
	_lpD3DD->SetRenderState(D3DRENDERSTATE_CULLMODE, D3DCULL_NONE);
//	_lpD3DD->SetRenderState();
//	_lpD3DD->SetRenderState(D3DRENDERSTATE_DITHERENABLE, TRUE);
	_lpD3DD->SetRenderState(D3DRENDERSTATE_TEXTUREMIN, D3DFILTER_LINEAR);
	_lpD3DD->SetRenderState(D3DRENDERSTATE_TEXTUREMAG, D3DFILTER_LINEAR);
	_lpD3DD->SetRenderState(D3DRENDERSTATE_FOGCOLOR, 0x00000000);
//	_lpD3DD->SetRenderState(D3DRENDERSTATE_TEXTUREMAPBLEND, D3DTBLEND_DECAL);
	_lpD3DD->SetRenderState(D3DRENDERSTATE_SHADEMODE, D3DSHADE_GOURAUD);
	_lpD3DD->SetRenderState(D3DRENDERSTATE_SUBPIXEL, TRUE);

//	grColorMask(TRUE, TRUE);					// ?
	grDitherMode(GR_DITHER_4x4);
	grDepthBufferFunction(GR_CMP_LEQUAL);
	grDepthBufferMode(GR_DEPTHBUFFER_DISABLE);
	grColorCombine(GR_COMBINE_FUNCTION_SCALE_OTHER, GR_COMBINE_FACTOR_ONE, GR_COMBINE_LOCAL_ITERATED, GR_COMBINE_OTHER_ITERATED, 0);
	grTexClampMode(0, GR_TEXTURECLAMP_WRAP, GR_TEXTURECLAMP_WRAP);
	grConstantColorValue(0xFFFFFFFF);

	grBufferClear(0, 0, 0);
	grBufferSwap(0);
	grBufferClear(0, 0, 0);
	grBufferSwap(0);

//	Voodoo.lastpolytype = D3DPT_TRIANGLELIST;
//	_lpD3DD->Begin(D3DPT_TRIANGLELIST, D3DFVF_TLVERTEX, D3DDP_DONOTLIGHT | D3DDP_WAIT);

	log("  Finished grSstWinOpen successfully");


	return FXTRUE;
//	return FXFALSE;
}

/* Important */
FX_ENTRY void FX_CALL grSstWinClose( void ) {
	log("Called grSstWinClose");

	_lpD3DD->EndScene();
	_lpD3DFrame->DestroyObjects();
}


/* Important */
FX_ENTRY void FX_CALL grSstSelect(int which_sst ) {
	log("Called grSstSelect: sst=" << which_sst);

	if (_errorFnc && (which_sst != 0))
		_errorFnc("Invalid board selected", FXFALSE); // Error if board 0 is not selected.
}

/* Important */
FX_ENTRY FxU32 FX_CALL grSstScreenHeight( void ) {
	log("Called grSstScreenHeight");

	return Voodoo.height;
}

/* Important */
FX_ENTRY FxU32 FX_CALL grSstScreenWidth( void ) {
	log("Called grSstScreenWidth");

	return Voodoo.width;
}

FX_ENTRY FxBool FX_CALL grSstQueryHardware( GrHwConfiguration *hwconfig ) {
	log("Called grSstQueryHardware");

	hwconfig->num_sst = 1; // One subsystem...
	hwconfig->SSTs[0].type = GR_SSTTYPE_VOODOO; // ...of Voodoo type
	hwconfig->SSTs[0].sstBoard.VoodooConfig.fbRam = Voodoo.fbRam; // This many megs for the frame buffer
	hwconfig->SSTs[0].sstBoard.VoodooConfig.fbiRev = 1; // Revision number... not sure what this should be.
	hwconfig->SSTs[0].sstBoard.VoodooConfig.nTexelfx = 1; // 1 virtual TexelFX chip installed
	hwconfig->SSTs[0].sstBoard.VoodooConfig.sliDetect = FXFALSE; // Not SLI
	hwconfig->SSTs[0].sstBoard.VoodooConfig.tmuConfig[0].tmuRev = 1; // Revision number... not sure what this should be. 
	hwconfig->SSTs[0].sstBoard.VoodooConfig.tmuConfig[0].tmuRam = _tmuRam; // This many megs for the texture unit

	return FXTRUE;
}

/* Important */
FX_ENTRY FxBool FX_CALL grSstQueryBoards( GrHwConfiguration *hwconfig ) {
	log("Called grSstQueryBoards");

	memset(hwconfig, 0, sizeof(GrHwConfiguration)); // Added 2/2/99
	hwconfig->num_sst = 1; // We have one virtual board installed

	return FXTRUE;
}


/* Only for Marble32 */
FX_ENTRY FxBool FX_CALL grSstControl(FxU32 i) {
	vlog("Called grSstControl: value=" << i);

	return FXTRUE;
}
